SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
sf::RectangleShape Class Reference
Graphics module

Specialized shape representing a rectangle. More...

`#include <RectangleShape.hpp>`

Inheritance diagram for sf::RectangleShape:

## Public Member Functions
| RectangleShape (const Vector2f &size=Vector2f(0, 0))
| Default constructor. More...
void | setSize (const Vector2f &size)
| Set the size of the rectangle. More...
const Vector2f & | getSize () const
| Get the size of the rectangle. More...
virtual unsigned int | getPointCount () const
| Get the number of points defining the shape. More...
virtual Vector2f | getPoint (unsigned int index) const
| Get a point of the shape. More...
void | setTexture (const Texture *texture, bool resetRect=false)
| Change the source texture of the shape. More...
void | setTextureRect (const IntRect &rect)
| Set the sub-rectangle of the texture that the shape will display. More...
void | setFillColor (const Color &color)
| Set the fill color of the shape. More...
void | setOutlineColor (const Color &color)
| Set the outline color of the shape. More...
void | setOutlineThickness (float thickness)
| Set the thickness of the shape's outline. More...
const Texture * | getTexture () const
| Get the source texture of the shape. More...
const IntRect & | getTextureRect () const
| Get the sub-rectangle of the texture displayed by the shape. More...
const Color & | getFillColor () const
| Get the fill color of the shape. More...
const Color & | getOutlineColor () const
| Get the outline color of the shape. More...
float | getOutlineThickness () const
| Get the outline thickness of the shape. More...
FloatRect | getLocalBounds () const
| Get the local bounding rectangle of the entity. More...
FloatRect | getGlobalBounds () const
| Get the global bounding rectangle of the entity. More...
void | setPosition (float x, float y)
| set the position of the object More...
void | setPosition (const Vector2f &position)
| set the position of the object More...
void | setRotation (float angle)
| set the orientation of the object More...
void | setScale (float factorX, float factorY)
| set the scale factors of the object More...
void | setScale (const Vector2f &factors)
| set the scale factors of the object More...
void | setOrigin (float x, float y)
| set the local origin of the object More...
void | setOrigin (const Vector2f &origin)
| set the local origin of the object More...
const Vector2f & | getPosition () const
| get the position of the object More...
float | getRotation () const
| get the orientation of the object More...
const Vector2f & | getScale () const
| get the current scale of the object More...
const Vector2f & | getOrigin () const
| get the local origin of the object More...
void | move (float offsetX, float offsetY)
| Move the object by a given offset. More...
void | move (const Vector2f &offset)
| Move the object by a given offset. More...
void | rotate (float angle)
| Rotate the object. More...
void | scale (float factorX, float factorY)
| Scale the object. More...
void | scale (const Vector2f &factor)
| Scale the object. More...
const Transform & | getTransform () const
| get the combined transform of the object More...
const Transform & | getInverseTransform () const
| get the inverse of the combined transform of the object More...

## Protected Member Functions
void | update ()
| Recompute the internal geometry of the shape. More...

## Detailed Description

Specialized shape representing a rectangle.

This class inherits all the functions of sf::Transformable (position, rotation, scale, bounds, ...) as well as the functions of sf::Shape (outline, color, texture, ...).

Usage example:

sf::RectangleShape rectangle;
rectangle.setSize(sf::Vector2f(100, 50));
rectangle.setOutlineColor(sf::Color::Red);
rectangle.setOutlineThickness(5);
rectangle.setPosition(10, 20);
...
window.draw(rectangle);

See Also
  sf::Shape, sf::CircleShape, sf::ConvexShape

Definition at line 41 of file RectangleShape.hpp.

## Constructor & Destructor Documentation

sf::RectangleShape::RectangleShape | ( | const Vector2f & | size = `Vector2f(0, 0)`) |  |
| explicit

Default constructor.

Parameters

  size | Size of the rectangle

## Member Function Documentation

const Color& sf::Shape::getFillColor | ( | ) |  | const
| inherited

Get the fill color of the shape.

Returns
  Fill color of the shape

See Also
  setFillColor

FloatRect sf::Shape::getGlobalBounds | ( | ) |  | const
| inherited

Get the global bounding rectangle of the entity.

The returned rectangle is in global coordinates, which means that it takes in account the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the sprite in the global 2D world's coordinate system.

Returns
  Global bounding rectangle of the entity

const Transform& sf::Transformable::getInverseTransform | ( | ) |  | const
| inherited

get the inverse of the combined transform of the object

Returns
  Inverse of the combined transformations applied to the object

See Also
  getTransform

FloatRect sf::Shape::getLocalBounds | ( | ) |  | const
| inherited

Get the local bounding rectangle of the entity.

The returned rectangle is in local coordinates, which means that it ignores the transformations (translation, rotation, scale, ...) that are applied to the entity. In other words, this function returns the bounds of the entity in the entity's coordinate system.

Returns
  Local bounding rectangle of the entity

const Vector2f& sf::Transformable::getOrigin | ( | ) |  | const
| inherited

get the local origin of the object

Returns
  Current origin

See Also
  setOrigin

const Color& sf::Shape::getOutlineColor | ( | ) |  | const
| inherited

Get the outline color of the shape.

Returns
  Outline color of the shape

See Also
  setOutlineColor

float sf::Shape::getOutlineThickness | ( | ) |  | const
| inherited

Get the outline thickness of the shape.

Returns
  Outline thickness of the shape

See Also
  setOutlineThickness

virtual Vector2f sf::RectangleShape::getPoint | ( | unsigned int | index) |  | const
| virtual

Get a point of the shape.

The result is undefined if index is out of the valid range.

Parameters

  index | Index of the point to get, in range [0 .. getPointCount() - 1]

Returns
  Index-th point of the shape

Implements sf::Shape.

virtual unsigned int sf::RectangleShape::getPointCount | ( | ) |  | const
| virtual

Get the number of points defining the shape.

Returns
  Number of points of the shape

Implements sf::Shape.

const Vector2f& sf::Transformable::getPosition | ( | ) |  | const
| inherited

get the position of the object

Returns
  Current position

See Also
  setPosition

float sf::Transformable::getRotation | ( | ) |  | const
| inherited

get the orientation of the object

The rotation is always in the range [0, 360].

Returns
  Current rotation, in degrees

See Also
  setRotation

const Vector2f& sf::Transformable::getScale | ( | ) |  | const
| inherited

get the current scale of the object

Returns
  Current scale factors

See Also
  setScale

const Vector2f& sf::RectangleShape::getSize | ( | ) |  | const

Get the size of the rectangle.

Returns
  Size of the rectangle

See Also
  setSize

const Texture* sf::Shape::getTexture | ( | ) |  | const
| inherited

Get the source texture of the shape.

If the shape has no source texture, a NULL pointer is returned. The returned pointer is const, which means that you can't modify the texture when you retrieve it with this function.

Returns
  Pointer to the shape's texture

See Also
  setTexture

const IntRect& sf::Shape::getTextureRect | ( | ) |  | const
| inherited

Get the sub-rectangle of the texture displayed by the shape.

Returns
  Texture rectangle of the shape

See Also
  setTextureRect

const Transform& sf::Transformable::getTransform | ( | ) |  | const
| inherited

get the combined transform of the object

Returns
  Transform combining the position/rotation/scale/origin of the object

See Also
  getInverseTransform

void sf::Transformable::move | ( | float | offsetX,
|  | float | offsetY
| ) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f pos = object.getPosition();
object.setPosition(pos.x + offsetX, pos.y + offsetY);

Parameters

  offsetX | X offset
  offsetY | Y offset

See Also
  setPosition

void sf::Transformable::move | ( | const Vector2f & | offset) |  |
| inherited

Move the object by a given offset.

This function adds to the current position of the object, unlike setPosition which overwrites it. Thus, it is equivalent to the following code:

object.setPosition(object.getPosition() + offset);

Parameters

  offset | Offset

See Also
  setPosition

void sf::Transformable::rotate | ( | float | angle) |  |
| inherited

Rotate the object.

This function adds to the current rotation of the object, unlike setRotation which overwrites it. Thus, it is equivalent to the following code:

object.setRotation(object.getRotation() + angle);

Parameters

  angle | Angle of rotation, in degrees

void sf::Transformable::scale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factorX, scale.y * factorY);

Parameters

  factorX | Horizontal scale factor
  factorY | Vertical scale factor

See Also
  setScale

void sf::Transformable::scale | ( | const Vector2f & | factor) |  |
| inherited

Scale the object.

This function multiplies the current scale of the object, unlike setScale which overwrites it. Thus, it is equivalent to the following code:

sf::Vector2f scale = object.getScale();
object.setScale(scale.x * factor.x, scale.y * factor.y);

Parameters

  factor | Scale factors

See Also
  setScale

void sf::Shape::setFillColor | ( | const Color & | color) |  |
| inherited

Set the fill color of the shape.

This color is modulated (multiplied) with the shape's texture if any. It can be used to colorize the shape, or change its global opacity. You can use sf::Color::Transparent to make the inside of the shape transparent, and have the outline alone. By default, the shape's fill color is opaque white.

Parameters

  color | New color of the shape

See Also
  getFillColor, setOutlineColor

void sf::Transformable::setOrigin | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new origin
  y | Y coordinate of the new origin

See Also
  getOrigin

void sf::Transformable::setOrigin | ( | const Vector2f & | origin) |  |
| inherited

set the local origin of the object

The origin of an object defines the center point for all transformations (position, scale, rotation). The coordinates of this point must be relative to the top-left corner of the object, and ignore all transformations (position, scale, rotation). The default origin of a transformable object is (0, 0).

Parameters

  origin | New origin

See Also
  getOrigin

void sf::Shape::setOutlineColor | ( | const Color & | color) |  |
| inherited

Set the outline color of the shape.

By default, the shape's outline color is opaque white.

Parameters

  color | New outline color of the shape

See Also
  getOutlineColor, setFillColor

void sf::Shape::setOutlineThickness | ( | float | thickness) |  |
| inherited

Set the thickness of the shape's outline.

Note that negative values are allowed (so that the outline expands towards the center of the shape), and using zero disables the outline. By default, the outline thickness is 0.

Parameters

  thickness | New outline thickness

See Also
  getOutlineThickness

void sf::Transformable::setPosition | ( | float | x,
|  | float | y
| ) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  x | X coordinate of the new position
  y | Y coordinate of the new position

See Also
  move, getPosition

void sf::Transformable::setPosition | ( | const Vector2f & | position) |  |
| inherited

set the position of the object

This function completely overwrites the previous position. See the move function to apply an offset based on the previous position instead. The default position of a transformable object is (0, 0).

Parameters

  position | New position

See Also
  move, getPosition

void sf::Transformable::setRotation | ( | float | angle) |  |
| inherited

set the orientation of the object

This function completely overwrites the previous rotation. See the rotate function to add an angle based on the previous rotation instead. The default rotation of a transformable object is 0.

Parameters

  angle | New rotation, in degrees

See Also
  rotate, getRotation

void sf::Transformable::setScale | ( | float | factorX,
|  | float | factorY
| ) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factorX | New horizontal scale factor
  factorY | New vertical scale factor

See Also
  scale, getScale

void sf::Transformable::setScale | ( | const Vector2f & | factors) |  |
| inherited

set the scale factors of the object

This function completely overwrites the previous scale. See the scale function to add a factor based on the previous scale instead. The default scale of a transformable object is (1, 1).

Parameters

  factors | New scale factors

See Also
  scale, getScale

void sf::RectangleShape::setSize | ( | const Vector2f & | size) |  |

Set the size of the rectangle.

Parameters

  size | New size of the rectangle

See Also
  getSize

void sf::Shape::setTexture | ( | const Texture * | texture,
|  | bool | resetRect = `false`
| ) |  |
| inherited

Change the source texture of the shape.

The texture argument refers to a texture that must exist as long as the shape uses it. Indeed, the shape doesn't store its own copy of the texture, but rather keeps a pointer to the one that you passed to this function. If the source texture is destroyed and the shape tries to use it, the behaviour is undefined. texture can be NULL to disable texturing. If resetRect is true, the TextureRect property of the shape is automatically adjusted to the size of the new texture. If it is false, the texture rect is left unchanged.

Parameters

  texture | New texture
  resetRect | Should the texture rect be reset to the size of the new texture?

See Also
  getTexture, setTextureRect

void sf::Shape::setTextureRect | ( | const IntRect & | rect) |  |
| inherited

Set the sub-rectangle of the texture that the shape will display.

The texture rect is useful when you don't want to display the whole texture, but rather a part of it. By default, the texture rect covers the entire texture.

Parameters

  rect | Rectangle defining the region of the texture to display

See Also
  getTextureRect, setTexture

void sf::Shape::update | ( | ) |  |
| protected inherited

Recompute the internal geometry of the shape.

This function must be called by the derived class everytime the shape's points change (ie. the result of either getPointCount or getPoint is different).

The documentation for this class was generated from the following file:

- RectangleShape.hpp